Index: issm/trunk/src/m/classes/plumebasalforcings.py
===================================================================
--- issm/trunk/src/m/classes/plumebasalforcings.py	(revision 25994)
+++ issm/trunk/src/m/classes/plumebasalforcings.py	(revision 26744)
@@ -39,13 +39,13 @@
         else:
             error('constuctor not supported')
-    #}}}
+    # }}}
 
     def __repr__(self):  # {{{
         s = '   mantle plume basal melt parameterization:\n'
-        s += '{}\n'.format(fielddisplay(self, 'groundedice_melting_rate', 'basal melting rate (positive if melting) [m / yr]'))
-        s += '{}\n'.format(fielddisplay(self, 'floatingice_melting_rate', 'basal melting rate (positive if melting) [m / yr]'))
-        s += '{}\n'.format(fielddisplay(self, 'mantleconductivity', 'mantle heat conductivity [W / m^3]'))
+        s += '{}\n'.format(fielddisplay(self, 'groundedice_melting_rate', 'basal melting rate (positive if melting) [m/yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'floatingice_melting_rate', 'basal melting rate (positive if melting) [m/yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'mantleconductivity', 'mantle heat conductivity [W/m^3]'))
         s += '{}\n'.format(fielddisplay(self, 'nusselt', 'nusselt number, ratio of mantle to plume [1]'))
-        s += '{}\n'.format(fielddisplay(self, 'dtbg', 'background temperature gradient [degree / m]'))
+        s += '{}\n'.format(fielddisplay(self, 'dtbg', 'background temperature gradient [degree/m]'))
         s += '{}\n'.format(fielddisplay(self, 'plumeradius', 'radius of the mantle plume [m]'))
         s += '{}\n'.format(fielddisplay(self, 'topplumedepth', 'depth of the mantle plume top below the crust [m]'))
@@ -55,8 +55,8 @@
         s += '{}\n'.format(fielddisplay(self, 'crustthickness', 'thickness of the crust [m]'))
         s += '{}\n'.format(fielddisplay(self, 'uppercrustthickness', 'thickness of the upper crust [m]'))
-        s += '{}\n'.format(fielddisplay(self, 'uppercrustheat', 'volumic heat of the upper crust [w / m^3]'))
-        s += '{}\n'.format(fielddisplay(self, 'lowercrustheat', 'volumic heat of the lowercrust [w / m^3]'))
+        s += '{}\n'.format(fielddisplay(self, 'uppercrustheat', 'volumic heat of the upper crust [w/m^3]'))
+        s += '{}\n'.format(fielddisplay(self, 'lowercrustheat', 'volumic heat of the lowercrust [w/m^3]'))
         return s
-    #}}}
+    # }}}
 
     def initialize(self, md):  #{{{
@@ -68,5 +68,5 @@
             print('      no basalforcings.floatingice_melting_rate specified: values set as zero')
         return self
-    #}}}
+    # }}}
 
     def extrude(self, md):  # {{{
@@ -74,5 +74,5 @@
         self.floatingice_melting_rate = project3d(md, 'vector', self.floatingice_melting_rate, 'type', 'node', 'layer', 1)
         return self
-    #}}}
+    # }}}
 
     def setdefaultparameters(self):  # {{{
@@ -80,5 +80,5 @@
         self.mantleconductivity = 2.2
         self.nusselt = 300
-        self.dtbg = 11 / 1000.
+        self.dtbg = 11 / 1000.0
         self.plumeradius = 100000
         self.topplumedepth = 10000
@@ -86,8 +86,8 @@
         self.crustthickness = 30000
         self.uppercrustthickness = 14000
-        self.uppercrustheat = 1.7 * 10**-6
-        self.lowercrustheat = 0.4 * 10**-6
+        self.uppercrustheat = 1.7 * pow(10, -6)
+        self.lowercrustheat = 0.4 * pow(10, -6)
         return self
-    #}}}
+    # }}}
 
     def checkconsistency(self, md, solution, analyses):  # {{{
Index: issm/trunk/src/m/classes/qmu.js
===================================================================
--- issm/trunk/src/m/classes/qmu.js	(revision 25994)
+++ issm/trunk/src/m/classes/qmu.js	(revision 26744)
@@ -12,5 +12,7 @@
 		console.log(sprintf('   qmu parameters:'));
 
-		/*fielddisplay(this,'isdakota','is qmu analysis activated?');
+		fielddisplay(this,'isdakota','is qmu analysis activated?');
+		fielddisplay(this,'output','are we outputting ISSM results, default is 0');
+		/*
 		for (var i=0;i<this.variables.length;i++){
 			console.log(sprintf('         variables%s:  (arrays of each variable class)',...
@@ -106,4 +108,5 @@
 		this.marshall=function(md,prefix,fid) { //{{{
 			WriteData(fid,prefix,'object',this,'fieldname','isdakota','format','Boolean');
+			WriteData(fid,prefix,'object',this,'fieldname','output','format','Boolean');
 			if (!this.isdakota){
 				WriteData(fid,prefix,'data',0,'name','md.qmu.mass_flux_segments_present','format','Boolean');
@@ -129,4 +132,5 @@
 
 	this.isdakota                    = 0;
+	this.output                      = 0;
 	this.variables                   = []
 	this.responses                   = [];
Index: issm/trunk/src/m/classes/qmu.m
===================================================================
--- issm/trunk/src/m/classes/qmu.m	(revision 25994)
+++ issm/trunk/src/m/classes/qmu.m	(revision 26744)
@@ -88,5 +88,5 @@
 					md = checkmessage(md,['evaluation_scheduling in qmu.params should be set to ''master''']);
 				end
-				if md.cluster.np<=1,
+				if md.cluster.nprocs()<=1,
 					md = checkmessage(md,['in parallel library mode, Dakota needs to run on at least 2 cpus, 1 cpu for the master, 1 cpu for the slave. Modify md.cluster.np accordingly.']);
 				end
@@ -95,5 +95,5 @@
 					md = checkmessage(md,['in parallel library mode, Dakota needs to run at least one slave on one cpu (md.qmu.params.processors_per_evaluation >=1)!']);
 				end
-				if mod(md.cluster.np-1,self.params.processors_per_evaluation),
+				if mod(md.cluster.nprocs()-1,self.params.processors_per_evaluation),
 					%md = checkmessage(md,['in parallel library mode, the requirement is for md.cluster.np = md.qmu.params.processors_per_evaluation * number_of_slaves, where number_of_slaves will automatically be determined by Dakota. Modify md.cluster.np accordingly']);
 				end
Index: issm/trunk/src/m/classes/qmu.py
===================================================================
--- issm/trunk/src/m/classes/qmu.py	(revision 25994)
+++ issm/trunk/src/m/classes/qmu.py	(revision 26744)
@@ -149,5 +149,5 @@
                 md.checkmessage('evaluation_scheduling in qmu.params should be set to "master"')
 
-            if md.cluster.np <= 1:
+            if md.cluster.nprocs() <= 1:
                 md.checkmessage('in parallel library mode, Dakota needs to run on at least 2 cpus, 1 cpu for the master, 1 cpu for the slave. Modify md.cluster.np accordingly.')
 
@@ -155,5 +155,5 @@
                 md.checkmessage('in parallel library mode, Dakota needs to run at least one slave on one cpu (md.qmu.params.processors_per_evaluation >= 1)!')
 
-            if np.mod(md.cluster.np - 1, self.params.processors_per_evaluation):
+            if np.mod(md.cluster.nprocs() - 1, self.params.processors_per_evaluation):
                 #md.checkmessage('in parallel library mode, the requirement is for md.cluster.np = md.qmu.params.processors_per_evaluation * number_of_slaves, where number_of_slaves will automatically be determined by Dakota. Modify md.cluster.np accordingly')
                 pass
Index: issm/trunk/src/m/classes/qmu/dakota_method/dmeth_params_write.m
===================================================================
--- issm/trunk/src/m/classes/qmu/dakota_method/dmeth_params_write.m	(revision 25994)
+++ issm/trunk/src/m/classes/qmu/dakota_method/dmeth_params_write.m	(revision 26744)
@@ -598,6 +598,4 @@
 	else
 		warning('param_write:param_unrecog','Parameter ''%s'' is of unrecognized type ''%s''.',pname,class(params.(pname)));
-		return
 	end
-
 end% }}}
Index: issm/trunk/src/m/classes/qmu/dakota_method/dmeth_params_write.py
===================================================================
--- issm/trunk/src/m/classes/qmu/dakota_method/dmeth_params_write.py	(revision 25994)
+++ issm/trunk/src/m/classes/qmu/dakota_method/dmeth_params_write.py	(revision 26744)
@@ -7,7 +7,7 @@
 
 def dmeth_params_write(dm, fid, sbeg='\t  '):
-    '''  write the parameters from a dakota_method object.
+    """write the parameters from a dakota_method object.
     [] = dmeth_params_write(dm, fid, sbeg)
-    '''
+    """
 
     if not isinstance(dm, dakota_method):
@@ -509,10 +509,10 @@
     #  check for errors
     if not isfield(params, pname):
-        warning('param_write:param_not_found', 'Parameter ' + str(pname) + ' not found in ' + params + '.')
+        print('Warning: dmeth_params_write.py::param_write: Parameter {} not found in {}.'.format(pname, params))
         return
     elif type(vars(params)[pname]) == bool and not vars(params)[pname]:
         return
     elif isempty(vars(params)[pname]):
-        print('Warning: param_write:param_empty: Parameter {} requires input of type {}.'.format(pname, type(vars(params)[pname])))
+        print('Warning: dmeth_params_write.py::param_write: Parameter {} requires input of type {}.'.format(pname, type(vars(params)[pname])))
         return
 
@@ -535,4 +535,4 @@
 
     else:
-        print('Warning: param_write:param_unrecog: Parameter {} is of unrecognized type {}.'.format(pname, type(vars(params)[pname])))
-        return
+        print('Warning: dmeth_params_write.py::param_write: Parameter {} is of unrecognized type {}.'.format(pname, type(vars(params)[pname])))
+    return
Index: issm/trunk/src/m/classes/qmustatistics.m
===================================================================
--- issm/trunk/src/m/classes/qmustatistics.m	(revision 25994)
+++ issm/trunk/src/m/classes/qmustatistics.m	(revision 26744)
@@ -14,5 +14,5 @@
 
 		%name: name of method, one of 'None','Histogram','SampleSeries' or 'MeanVariance'
-		%fields: fields for the  statistics being requested, ex: 'Sealevel','BslrIce','BslrHydro'
+		%fields: fields for the  statistics being requested, ex: 'Sealevel','BslcIce','BslcHydro'
 		%steps: time steps at which each field statistic is computed, ex: [1:2,5,20] or 1:100
 		%nbins: number of bins for 'Histogram' statistics
Index: issm/trunk/src/m/classes/rotational.js
===================================================================
--- issm/trunk/src/m/classes/rotational.js	(revision 26744)
+++ issm/trunk/src/m/classes/rotational.js	(revision 26744)
@@ -0,0 +1,58 @@
+class rotational {//{{{
+	/**
+	 * ROTATIONAL class definition
+	 *
+	 * Usage:
+	 *     rotational = rotational();
+	 */
+	constructor() {//{{{
+		this.equatorialmoi		= 0;
+		this.polarmoi			= 0;
+		this.angularvelocity	= 0;
+
+		let nargs = arguments.length;
+		if (nargs == 0) {
+			this.setdefaultparameters();
+		} else {
+			error('constructor not supported');
+		}
+	} //}}}
+
+	disp() {//{{{
+		console.log('WARNING: rotational::disp is not yet implemented');
+	} //}}}
+
+	setdefaultparameters() {//{{{
+		// Moment of inertia
+		this.equatorialmoi	= 8.0077e37; // [kg m^2]
+		this.polarmoi		= 8.0345e37; // [kg m^2]
+
+		// Mean rotational velocity of earth
+		this.angularvelocity = 7.2921e-5; // [s^-1]
+	} //}}}
+
+	checkconsistency(md, solution, analyses) {//{{{
+		if (!analyses.includes('SealevelchangeAnalysis') || (solution === 'TransientSolution' && !md.transient.isslc)) {
+			return md;
+		}
+
+		md = checkfield(md, 'fieldname', 'solidearth.rotational.equatorialmoi', 'NaN', 1, 'Inf', 1);
+		md = checkfield(md, 'fieldname', 'solidearth.rotational.polarmoi', 'NaN', 1, 'Inf', 1);
+		md = checkfield(md, 'fieldname', 'solidearth.rotational.angularvelocity', 'NaN', 1, 'Inf', 1);
+
+		return md;
+	} //}}}
+
+	defaultoutputs(md) {//{{{
+		return [];
+	} //}}}
+
+	marshall(md, prefix, fid) {//{{{
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'equatorialmoi', 'name', 'md.solidearth.rotational.equatorialmoi', 'format', 'Double');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'polarmoi', 'name', 'md.solidearth.rotational.polarmoi', 'format', 'Double');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'angularvelocity', 'name', 'md.solidearth.rotational.angularvelocity', 'format', 'Double');
+	} //}}}
+
+	extrude(md) {//{{{
+	} //}}}
+} //}}}
Index: issm/trunk/src/m/classes/rotational.m
===================================================================
--- issm/trunk/src/m/classes/rotational.m	(revision 25994)
+++ issm/trunk/src/m/classes/rotational.m	(revision 26744)
@@ -20,15 +20,15 @@
 		end % }}}
 		function self = setdefaultparameters(self) % {{{
-		
-		%moment of inertia: 
-		self.equatorialmoi	=8.0077*10^37; % [kg m^2] 
-		self.polarmoi		=8.0345*10^37; % [kg m^2] 
 
-		% mean rotational velocity of earth 
-		self.angularvelocity=7.2921*10^-5; % [s^-1] 
+			%moment of inertia:
+			self.equatorialmoi	=8.0077*10^37; % [kg m^2]
+			self.polarmoi		=8.0345*10^37; % [kg m^2]
+
+			% mean rotational velocity of earth
+			self.angularvelocity=7.2921*10^-5; % [s^-1]
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
 
-			if ~ismember('SealevelriseAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.transient.isslr==0), 
+			if ~ismember('SealevelchangeAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.transient.isslc==0), 
 				return; 
 			end
Index: issm/trunk/src/m/classes/rotational.py
===================================================================
--- issm/trunk/src/m/classes/rotational.py	(revision 25994)
+++ issm/trunk/src/m/classes/rotational.py	(revision 26744)
@@ -1,4 +1,2 @@
-import numpy as np
-
 from checkfield import checkfield
 from fielddisplay import fielddisplay
@@ -13,8 +11,8 @@
     """
 
-    def __init__(self, *args): #{{{
-        self.equatorialmoi      = 0
-        self.polarmoi           = 0
-        self.langularvelocity   = 0
+    def __init__(self, *args):  #{{{
+        self.equatorialmoi = 0
+        self.polarmoi = 0
+        self.langularvelocity = 0
 
         nargin = len(args)
@@ -25,5 +23,5 @@
     #}}}
 
-    def __repr__(self): # {{{
+    def __repr__(self):  # {{{
         s = '   rotational parameters:\n'
         s += '{}\n'.format(fielddisplay(self, 'equatorialmoi', 'mean equatorial moment of inertia [kg m^2]'))
@@ -33,16 +31,16 @@
     #}}}
 
-    def setdefaultparameters(self): # {{{
+    def setdefaultparameters(self):  # {{{
         # Moment of inertia
-        self.equatorialmoi  = 8.0077e37 # [kg m^2]
-        self.polarmoi       = 8.0345e37 # [kg m^2]
+        self.equatorialmoi = 8.0077 * pow(10, 37) # [kg m^2]
+        self.polarmoi = 8.0345 * pow(10, 37) # [kg m^2]
 
         # Mean rotational velocity of earth
-        self.angularvelocity = 7.2921e-5 # [s^-1]
+        self.angularvelocity = 7.2921 * pow(10, -5) # [s^-1]
         return self
     #}}}
 
-    def checkconsistency(self, md, solution, analyses): # {{{
-        if ('SealevelriseAnalysis' not in analyses) or (solution == 'TransientSolution' and not md.transient.isslr):
+    def checkconsistency(self, md, solution, analyses):  # {{{
+        if ('SealevelchangeAnalysis' not in analyses) or (solution == 'TransientSolution' and not md.transient.isslc):
             return md
         md = checkfield(md, 'fieldname', 'solidearth.rotational.equatorialmoi', 'NaN', 1, 'Inf', 1)
@@ -52,9 +50,9 @@
     #}}}
 
-    def defaultoutputs(self, md): #{{{
+    def defaultoutputs(self, md):  #{{{
         return []
     #}}}
 
-    def marshall(self, prefix, md, fid): #{{{
+    def marshall(self, prefix, md, fid):  #{{{
         WriteData(fid, prefix, 'object', self, 'fieldname', 'equatorialmoi', 'name', 'md.solidearth.rotational.equatorialmoi', 'format', 'Double')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'polarmoi', 'name', 'md.solidearth.rotational.polarmoi', 'format', 'Double')
@@ -62,5 +60,5 @@
     #}}}
 
-    def extrude(self, md): #{{{
+    def extrude(self, md):  #{{{
         return self
     #}}}
Index: issm/trunk/src/m/classes/sampling.js
===================================================================
--- issm/trunk/src/m/classes/sampling.js	(revision 26744)
+++ issm/trunk/src/m/classes/sampling.js	(revision 26744)
@@ -0,0 +1,99 @@
+//SAMPLING class definition
+//
+//   Usage:
+//      sampling=new sampling();
+
+function sampling (){
+	//methods
+	this.defaultoutputs = function(){// {{{
+       	return [];
+	}// }}}
+	this.setdefaultparameters = function(){// {{{
+
+		//Scaling coefficient
+		this.tau=1;  
+
+		//Apply Robin boundary conditions
+		this.robin=0;   
+		
+		//Temporal correlation factor
+		this.phi=0;  
+		
+		//Exponent in fraction SPDE (default=2, biLaplacian covariance
+		//operator)
+		this.alpha=2; // Default 
+		
+		//Seed for pseudorandom number generator (default -1 for random seed)
+		this.seed=-1;
+		
+		//default output
+		this.requested_outputs=['default'];
+	}// }}}
+	this.disp= function(){// {{{
+		console.log(sprintf('   Sampling parameters:'));
+
+		console.log(sprintf('\n      %s','Parameters of PDE operator (kappa^2 I-Laplacian)^(alpha/2)(tau):'));
+		fielddisplay(this,'kappa','coefficient of the identity operator');
+		fielddisplay(this,'tau','scaling coefficient of the solution (default 1.0)');
+		fielddisplay(this,'alpha','exponent in PDE operator, (default 2.0, BiLaplacian covariance operator)');
+	  
+		console.log(sprintf('\n      %s','Parameters of Robin boundary conditions nabla () \cdot normvec + beta ():'));
+		fielddisplay(this,'robin','Apply Robin boundary conditions (1 if applied and 0 for homogenous Neumann boundary conditions) (default 0)');
+		fielddisplay(this,'beta','Coefficient in Robin boundary conditions (to be defined for robin = 1)');          
+		
+		console.log(sprintf('\n      %s','Parameters for first-order autoregressive process (X_t = phi X_{t-1} + noise) (if transient):'));
+		fielddisplay(this,'phi','Temporal correlation factor (|phi|<1 for stationary process, phi = 1 for random walk process) (default 0)');
+		
+		console.log(sprintf('\n      %s','Other parameters of stochastic sampler:'));
+		fielddisplay(this,'seed','Seed for pseudorandom number generator (given seed if >=0 and random seed if <0) (default -1)');
+		fielddisplay(this,'requested_outputs','additional outputs requested (not implemented yet)');
+	}// }}}
+	this.classname= function(){// {{{
+		return "sampling";
+	}// }}}
+	this.checkconsistency = function(md,solution,analyses) { //{{{
+		if (!ismember('SamplingAnalysis',analyses)) return;
+		
+		checkfield(md,'fieldname','sampling.kappa','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices,1],'>',0);
+		checkfield(md,'fieldname','sampling.tau','NaN',1,'Inf',1,'numel',1,'>',0);
+		checkfield(md,'fieldname','sampling.robin','numel',1,'values',[0,1]);
+		if (md.sampling.robin) {
+			checkfield(md,'fieldname','sampling.beta','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices,1],'>',0);
+		}
+		checkfield(md,'fieldname','sampling.phi','NaN',1,'Inf',1,'numel',1,'>=',0);
+		checkfield(md,'fieldname','sampling.alpha','NaN',1,'Inf',1,'numel',1,'>',0);
+		checkfield(md,'fieldname','sampling.seed','NaN',1,'Inf',1,'numel',1);
+		checkfield(md,'fieldname','sampling.requested_outputs','stringrow',1);
+	} // }}}
+	this.marshall=function(md,prefix,fid) { //{{{
+		WriteData(fid,prefix,'object',this,'fieldname','kappa','format','DoubleMat','mattype',1);
+		WriteData(fid,prefix,'object',this,'fieldname','tau','format','Double');
+		WriteData(fid,prefix,'object',this,'fieldname','beta','format','DoubleMat','mattype',1);
+		WriteData(fid,prefix,'object',this,'fieldname','phi','format','Double');
+		WriteData(fid,prefix,'object',this,'fieldname','alpha','format','Integer');
+		WriteData(fid,prefix,'object',this,'fieldname','robin','format','Boolean');
+		WriteData(fid,prefix,'object',this,'fieldname','seed','format','Integer');
+		
+		//process requested outputs
+		outputs = this.requested_outputs;
+		pos = find(ismember(outputs,'default'));
+		if (!isempty(pos)) {
+			ArrayIndex(outputs,pos,[]);                         //remove 'default' from outputs
+			outputs = ArrayConcat(outputs, this.defaultoutputs()); //add defaults
+		}
+		WriteData(fid,prefix,'data',outputs,'name','md.sampling.requested_outputs','format','StringArray');
+	}//}}}
+	//properties 
+	// {{{
+    this.kappa          	= NaN;
+	this.tau            	= 0;
+	this.beta           	= NaN;
+    this.phi            	= 0;
+    this.alpha          	= 0;
+    this.robin          	= 0;
+    this.seed           	= 0;
+	this.requested_outputs  = [];
+
+	this.setdefaultparameters();
+	//}}}
+}
Index: issm/trunk/src/m/classes/sampling.m
===================================================================
--- issm/trunk/src/m/classes/sampling.m	(revision 26744)
+++ issm/trunk/src/m/classes/sampling.m	(revision 26744)
@@ -0,0 +1,131 @@
+%SAMPLING class definition
+%
+%   Usage:
+%      sampling=sampling();
+
+classdef sampling
+	properties (SetAccess=public)
+		kappa             = NaN;
+		tau               = 0;
+		beta              = NaN;
+		phi               = 0;
+		alpha             = 0;
+		robin             = 0;
+		seed              = 0;
+		requested_outputs = {};
+	end
+	methods
+		function self = sampling(varargin) % {{{
+			switch nargin
+				case 0
+					self=setdefaultparameters(self);
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+		function disp(self) % {{{
+
+			disp(sprintf('   Sampling parameters:'));
+
+			disp(sprintf('\n      %s','Parameters of PDE operator (kappa^2 I-Laplacian)^(alpha/2)(tau):'));
+			fielddisplay(self,'kappa','coefficient of the identity operator');
+			fielddisplay(self,'tau','scaling coefficient of the solution (default: 1.0)');
+			fielddisplay(self,'alpha','exponent in PDE operator, (default: 2.0, BiLaplacian covariance operator)');
+
+			disp(sprintf('\n      %s','Parameters of Robin boundary conditions nabla () \cdot normvec + beta ():'));
+			fielddisplay(self,'robin','Apply Robin boundary conditions (1 if applied and 0 for homogenous Neumann boundary conditions) (default: 0)');
+			fielddisplay(self,'beta','Coefficient in Robin boundary conditions (to be defined for robin = 1)');
+
+			disp(sprintf('\n      %s','Parameters for first-order autoregressive process (X_t = phi X_{t-1} + noise) (if transient):'));
+			fielddisplay(self,'phi','Temporal correlation factor (|phi|<1 for stationary process, phi = 1 for random walk process) (default 0)');
+
+			disp(sprintf('\n      %s','Other parameters of stochastic sampler:'));
+			fielddisplay(self,'seed','Seed for pseudorandom number generator (given seed if >=0 and random seed if <0) (default: -1)');
+			fielddisplay(self,'requested_outputs','additional outputs requested (not implemented yet)');
+
+		end % }}}','
+		function self = setdefaultparameters(self) % {{{
+
+			%Scaling coefficient
+			self.tau=1;
+
+			%Apply Robin boundary conditions
+			self.robin=0;
+
+			%Temporal correlation factor
+			self.phi=0;
+
+			%Exponent in fraction SPDE (default: 2, biLaplacian covariance
+			%operator)
+			self.alpha=2; % Default 
+
+			%Seed for pseudorandom number generator (default: -1, for random seed)
+			self.seed=-1;
+
+			%default output
+			self.requested_outputs={'default'};
+
+		end % }}}
+		function list = defaultoutputs(self,md) % {{{
+
+			list = {};
+
+		end % }}}
+		function md = checkconsistency(self,md,solution,analyses) % {{{
+
+			if ~ismember('SamplingAnalysis',analyses), return; end
+
+			md = checkfield(md,'fieldname','sampling.kappa','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1],'>',0);
+			md = checkfield(md,'fieldname','sampling.tau','NaN',1,'Inf',1,'numel',1,'>',0);
+			md = checkfield(md,'fieldname','sampling.robin','numel',1,'values',[0 1]);
+			if(md.sampling.robin)
+				md = checkfield(md,'fieldname','sampling.beta','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1],'>',0);
+			end
+			md = checkfield(md,'fieldname','sampling.phi','NaN',1,'Inf',1,'numel',1,'>=',0);
+			md = checkfield(md,'fieldname','sampling.alpha','NaN',1,'Inf',1,'numel',1,'>',0);
+			md = checkfield(md,'fieldname','sampling.seed','NaN',1,'Inf',1,'numel',1);
+			md = checkfield(md,'fieldname','sampling.requested_outputs','stringrow',1);
+
+		end % }}}
+		function marshall(self,prefix,md,fid) % {{{
+
+			WriteData(fid,prefix,'object',self,'fieldname','kappa','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',self,'fieldname','tau','format','Double');
+			WriteData(fid,prefix,'object',self,'fieldname','beta','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',self,'fieldname','phi','format','Double');
+			WriteData(fid,prefix,'object',self,'fieldname','alpha','format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','robin','format','Boolean');
+			WriteData(fid,prefix,'object',self,'fieldname','seed','format','Integer');
+
+			%process requested outputs
+			outputs = self.requested_outputs;
+			pos  = find(ismember(outputs,'default'));
+			if ~isempty(pos),
+				outputs(pos) = [];                         %remove 'default' from outputs
+				outputs      = [outputs defaultoutputs(self,md)]; %add defaults
+			end
+			WriteData(fid,prefix,'data',outputs,'name','md.sampling.requested_outputs','format','StringArray');
+		end % }}}
+		function md = setparameters(self,md,lc,sigma) % {{{
+
+			nu = self.alpha-1;
+			KAPPA = sqrt(8*nu)/lc;
+			TAU = sqrt(gamma(nu)/(gamma(self.alpha)*(4*pi)*KAPPA^(2*nu)*sigma^2));
+			md.sampling.kappa = KAPPA*ones(md.mesh.numberofvertices,1);
+			md.sampling.tau = TAU;
+
+		end % }}}
+		function savemodeljs(self,fid,modelname) % {{{
+
+			writejsdouble(fid,[modelname '.sampling.kappa'],self.kappa);
+			writejsdouble(fid,[modelname '.sampling.tau'],self.tau);
+			writejsdouble(fid,[modelname '.sampling.beta'],self.beta);
+			writejsdouble(fid,[modelname '.sampling.phi'],self.beta);
+			writejsdouble(fid,[modelname '.sampling.alpha'],self.alpha);
+			writejsdouble(fid,[modelname '.sampling.robin'],self.robin);
+			writejsdouble(fid,[modelname '.sampling.seed'],self.seed);
+			writejscellstring(fid,[modelname '.sampling.requested_outputs'],self.requested_outputs);
+
+		end % }}}
+	end
+end
Index: issm/trunk/src/m/classes/sampling.py
===================================================================
--- issm/trunk/src/m/classes/sampling.py	(revision 26744)
+++ issm/trunk/src/m/classes/sampling.py	(revision 26744)
@@ -0,0 +1,125 @@
+import numpy as np
+
+from math import *
+
+from checkfield import checkfield
+from fielddisplay import fielddisplay
+from project3d import project3d
+from WriteData import WriteData
+
+
+class sampling(object):
+    """SAMPLING class definition
+
+    Usage:
+        sampling = sampling()
+    """
+
+    def __init__(self, *args): #{{{
+        self.kappa = np.nan
+        self.tau = 0
+        self.beta = np.nan
+        self.phi = 0
+        self.alpha = 0
+        self.robin = 0
+        self.seed = 0
+        self.requested_outputs = []
+
+        if len(args) == 0:
+            self.setdefaultparameters()
+        else:
+            raise RuntimeError('constructor not supported')
+    #}}}
+
+    def __repr__(self): #{{{
+        s = '   Sampling parameters::\n'
+        s += '      Parameters of PDE operator (kappa^2 I-Laplacian)^(alpha/2)(tau):\n'
+        s += '{}\n'.format(fielddisplay(self, 'kappa', 'coefficient of the identity operator'))
+        s += '{}\n'.format(fielddisplay(self, 'tau', 'scaling coefficient of the solution (default: 1.0)'))
+        s += '{}\n'.format(fielddisplay(self, 'alpha', 'exponent in PDE operator, (default: 2.0, BiLaplacian covariance operator)'))
+
+        s += '      Parameters of Robin boundary conditions nabla () \cdot normvec + beta ():\n'
+        s += '{}\n'.format(fielddisplay(self, 'robin', 'Apply Robin boundary conditions (1 if applied and 0 for homogenous Neumann boundary conditions) (default: 0)'))
+        s += '{}\n'.format(fielddisplay(self, 'beta', 'Coefficient in Robin boundary conditions (to be defined for robin = 1)'))
+
+        s += '      Parameters for first-order autoregressive process (X_t = phi X_{t-1} + noise) (if transient):\n'
+        s += '{}\n'.format(fielddisplay(self, 'phi', 'Temporal correlation factor (|phi|<1 for stationary process, phi = 1 for random walk process) (default 0)'))
+
+        s += '      Other parameters of stochastic sampler:\n'
+        s += '{}\n'.format(fielddisplay(self, 'seed', 'Seed for pseudorandom number generator (given seed if >=0 and random seed if <0) (default: -1)'))
+        s += '{}\n'.format(fielddisplay(self, 'requested_outputs', 'additional outputs requested (not implemented yet)'))
+
+        return s
+    #}}}
+
+    def setdefaultparameters(self): #{{{
+        # Scaling coefficient
+        self.tau = 1
+
+        # Apply Robin boundary conditions
+        self.robin = 0
+
+        # Temporal correlation factor
+        self.phi = 0
+
+        # Exponent in fraction SPDE (default: 2, biLaplacian covariance operator)
+        self.alpha = 2
+
+        # Seed for pseudorandom number generator (default: -1, for random seed)
+        self.seed = -1
+
+        # Default output
+        self.requested_outputs = ['default']
+
+        return self
+    #}}}
+
+    def defaultoutputs(self, md): #{{{
+        return []
+    #}}}
+
+    def checkconsistency(self, md, solution, analyses): #{{{
+        if ('SamplingAnalysis' not in analyses):
+            return md
+
+        md = checkfield(md, 'fieldname', 'sampling.kappa', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices], '>', 0)
+        md = checkfield(md, 'fieldname', 'sampling.tau', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0)
+        md = checkfield(md, 'fieldname', 'sampling.robin', 'numel', 1, 'values', [0, 1])
+        if md.sampling.robin:
+            md = checkfield(md, 'fieldname', 'sampling.beta', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices], '>', 0)
+        end
+        md = checkfield(md, 'fieldname', 'sampling.phi', 'NaN', 1, 'Inf', 1, 'numel', 1, '>=', 0)
+        md = checkfield(md, 'fieldname', 'sampling.alpha', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0)
+        md = checkfield(md, 'fieldname', 'sampling.seed', 'NaN', 1, 'Inf', 1, 'numel', 1)
+        md = checkfield(md, 'fieldname', 'sampling.requested_outputs', 'stringrow', 1)
+
+        return md
+    #}}}
+
+    def marshall(self, prefix, md, fid): #{{{
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'kappa', 'format', 'DoubleMat', 'mattype', 1)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'tau', 'format', 'Double')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'beta', 'format', 'DoubleMat', 'mattype', 1)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'phi', 'format', 'Double')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'alpha', 'format', 'Integer')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'robin', 'format', 'Boolean')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'seed', 'format', 'Integer')
+
+        # Process requested outputs
+        outputs = self.requested_outputs
+        indices = [i for i, x in enumerate(outputs) if x == 'default']
+        if len(indices) > 0:
+            outputscopy = outputs[0:max(0, indices[0] - 1)] + self.defaultoutputs(md) + outputs[indices[0] + 1:]
+            outputs = outputscopy
+        WriteData(fid, prefix, 'data', outputs, 'name', 'md.sampling.requested_outputs', 'format', 'StringArray')
+    #}}}
+
+    def setparameters(self, md, lc, sigma): #{{{
+        nu = self.alpha - 1
+        KAPPA = pow((8 * nu), 0.5) / lc
+        TAU = pow((math.gamma(nu) / math.gamma(self.alpha) * (4 *  np.pi) * pow(KAPPA, 2 * nu) * pow(sigma, 2)), 0.5)
+        md.sampling.kappa = KAPPA * np.ones((md.mesh.numberofvertices, 1))
+        md.sampling.tau = TAU
+
+        return md
+    #}}}
